Subject: Re: [PATCH] powerpc/booke64: Configurable lazy interrupt disabling

From: Benjamin Herrenschmidt <[email-masked]>
Date: Sat, 21 Jan 2012 10:02:11 +1100

> With Topaz, interrupts go directly to guests and we don't want to require a
> trap/hcall to do an IACK, as that adds potentially thousands of cycles of
> latency to every interrupt.
> 
> As you know, with external proxy interrupts are acknowledged by the
> hardware and it becomes problematic to replay the interrupt in
> the context of lazy EE when interrupts are re-enabled.   The interrupt
> will not fire again when you enable EE.

So you have a broken HW and broken HV design to start with ... :-)

> That is currently the issue, as we can't run the 64-bit kernel on Topaz.
> Our option are:
>   1) to provide an option to disable lazy EE
>   2) do some kind of hack to replay interrupts with lazy EE
>   3) change Topaz to support legacy IACK, but this gets ugly for
>       various reasons.
> 
> Providing a config option to disable lazy EE seemed to be a good
> approach.

A config option is bad because it gets us yet another step toward
non-generic kernels.

Why don't you look into what would be needed to do a replay ? There are
many ways to achieve this, using the DEC is one that wouldn't involve
the hypervisor for example. But the case of an interrupt occurring while
masked is actually pretty low key so the overhead of an hcall at that
point wouldn't be too bad I beleive, so you could also implement some
kind of retry hcall which can internally be implemented using a guest
doorbell or something similar.

Cheers,
Ben.